<?php
/**
 * Theme Customizer
 */
function cryptocurrency_exchange_customize_register( $wp_customize ) {
   //All our sections, settings, and controls will be added here
   
	//Titles
    class cryptocurrency_exchange_info extends WP_Customize_Control {
        public $type = 'info';
        public $label = '';
        public function render_content() {
        ?>
            <h3 style="margin-top:30px;border-left:2px solid #E98D26;padding:7px;background-color:#E98D26;color:#232020;text-transform:uppercase;text-align:center;"><?php echo esc_html( $this->label ); ?></h3>
        <?php
        }
    }
		
		$wp_customize->remove_control('blogdescription');
		//cryptocurrency exchange Theme Options
		$wp_customize->add_panel('cryptocurrency_exchange_theme_options', array(
				'title' 	=> __( 'Theme Options', 'cryptocurrency-exchange' ),
				'priority' 	=> 1,
            )
        );
		
		//General Settings
		$wp_customize->add_section( 'cryptocurrency_exchange_general_settings' , array(
				'title'      	=> __( 'General Settings', 'cryptocurrency-exchange' ),
				'priority'      => 2,
				'panel'			=> 'cryptocurrency_exchange_theme_options',
			) 
		);
			
		//General Page Layout
		$wp_customize->add_setting( 'cryptocurrency_exchange_general_page_layout', array(
				'default'      		=> 'fullwidth',
				'sanitize_callback' => 'cryptocurrency_exchange_sanitize_radio'
			)
		);
		$wp_customize->add_control('cryptocurrency_exchange_general_page_layout', array(
				'type'      => 'radio',
				'label'     => __('Page layout', 'cryptocurrency-exchange'),
				'section'   => 'cryptocurrency_exchange_general_settings',
				'priority'  => 4,
				'choices'   => array(
					'leftsidebar'       => __( 'Left Sidebar', 'cryptocurrency-exchange' ),
					'fullwidth'         => __( 'Full width (no sidebar)', 'cryptocurrency-exchange' ),
					'rightsidebar'    	=> __( 'Right Sidebar', 'cryptocurrency-exchange' )
				),
			)
		);
		//General Settings End
		
		//Blog Options
		$wp_customize->add_section( 'cryptocurrency_exchange_blog_option' , array(
				'title'      	=> __( 'Blog Settings', 'cryptocurrency-exchange' ),
				'description'	=> __( 'You can change blog page layout and single blog page layout from here', 'cryptocurrency-exchange' ),
				'priority'      => 4,
				'panel'      	=> 'cryptocurrency_exchange_theme_options',
			) 
		);
		
			//Blog Page Layout
			$wp_customize->add_setting( 'cryptocurrency_exchange_page_layout_style', array(
					'default'      		=> 'rightsidebar',
					'sanitize_callback' => 'cryptocurrency_exchange_sanitize_radio'
				)
			);
			$wp_customize->add_control('cryptocurrency_exchange_page_layout_style', array(
					'type'      => 'radio',
					'label'     => __('Blog Page layout', 'cryptocurrency-exchange'),
					'section'   => 'cryptocurrency_exchange_blog_option',
					'priority'  => 1,
					'choices'   => array(
						'leftsidebar'       => __( 'Left Sidebar', 'cryptocurrency-exchange' ),
						'fullwidth'         => __( 'Full width (no sidebar)', 'cryptocurrency-exchange' ),
						'rightsidebar'    	=> __( 'Right Sidebar', 'cryptocurrency-exchange' )
					),
				)
			);
			
			//Blog Single Page Layout
			$wp_customize->add_setting( 'cryptocurrency_exchange_blog_single_page_layout', array(
					'default'      		=> 'fullwidth',
					'sanitize_callback' => 'cryptocurrency_exchange_sanitize_radio'
				)
			);
			$wp_customize->add_control('cryptocurrency_exchange_blog_single_page_layout', array(
					'type'      => 'radio',
					'label'     => __('Blog Single Page layout', 'cryptocurrency-exchange'),
					'section'   => 'cryptocurrency_exchange_blog_option',
					'priority'  => 2,
					'choices'   => array(
						'leftsidebar'       => __( 'Left Sidebar', 'cryptocurrency-exchange' ),
						'fullwidth'         => __( 'Full width (no sidebar)', 'cryptocurrency-exchange' ),
						'rightsidebar'    	=> __( 'Right Sidebar', 'cryptocurrency-exchange' )
					),
				)
			);	
			
		//Social Icon Settings
		$wp_customize->add_section( 'cryptocurrency_exchange_topbar_settings' , array(
				'title'      	=> __( 'Social Icon Settings', 'cryptocurrency-exchange' ),
				'priority'      => 5,
				'panel'			=> 'cryptocurrency_exchange_theme_options',
				'description'	=> __('Social Media icons will disappear if you leave it blank', 'cryptocurrency-exchange')
			) 
		);
			
			
			//Social Media
			$wp_customize->add_setting('cryptocurrency_title', array(
					'type'              => 'info_control',
					'capability'        => 'edit_theme_options',
					'sanitize_callback' => 'esc_attr',     
				)
			);
			
			$wp_customize->add_control( new cryptocurrency_exchange_info( $wp_customize, 'social_media', array(
						'label' 	=> __('Social Media', 'cryptocurrency-exchange'),
						'section' 	=> 'cryptocurrency_exchange_topbar_settings',
						'settings' 	=> 'cryptocurrency_title',
						'priority' 	=> 4,
					) 
				)
			);
			
			//Facebook link
			$wp_customize->add_setting( 'cryptocurrency_exchange_fb_link_disable', array(
					'default'           => 1,
					'sanitize_callback' => 'cryptocurrency_exchange_sanitize_checkbox',
				)
			);
			$wp_customize->add_control( 'cryptocurrency_exchange_fb_link_disable', array(
					'type'        => 'checkbox',
					'label'       => __('Disable Facebook Icon?', 'cryptocurrency-exchange'),
					'section'     => 'cryptocurrency_exchange_topbar_settings',
					'priority' 	  => 4,
				)
			);
			
			$wp_customize->add_setting('cryptocurrency_exchange_facebook_url', array( 
					'default' 			=> '',
					'sanitize_callback' => 'esc_url_raw'
					) 
				);
			$wp_customize->add_control('cryptocurrency_exchange_facebook_url', array(
					'description' 	=> __('Enter your Facebook url', 'cryptocurrency-exchange'),
					'section' 		=> 'cryptocurrency_exchange_topbar_settings',
					'type' 			=> 'url',
					'priority' 		=> 4,
				)
			);
			//Twitter URL
			$wp_customize->add_setting( 'cryptocurrency_exchange_tweet_link_disable', array(
					'default'           => 1,
					'sanitize_callback' => 'cryptocurrency_exchange_sanitize_checkbox',
				)
			);
			$wp_customize->add_control( 'cryptocurrency_exchange_tweet_link_disable', array(
					'type'        => 'checkbox',
					'label'       => __('Disable Twitter Icon?', 'cryptocurrency-exchange'),
					'section'     => 'cryptocurrency_exchange_topbar_settings',
					'priority' 	  => 4,
				)
			);
			
			$wp_customize->add_setting('cryptocurrency_exchange_twitter_url', array( 
					'default' 			=> '',
					'sanitize_callback' => 'esc_url_raw'
					) 
				);
			$wp_customize->add_control('cryptocurrency_exchange_twitter_url', array(
					'description' 	=> __('Enter your Twitter url', 'cryptocurrency-exchange'),
					'section' 		=> 'cryptocurrency_exchange_topbar_settings',
					'type' 			=> 'url',
					'priority' 		=> 4,
				)
			);
			
			//Instagram URL
			$wp_customize->add_setting( 'cryptocurrency_exchange_insta_link_disable', array(
					'default'           => 1,
					'sanitize_callback' => 'cryptocurrency_exchange_sanitize_checkbox',
				)
			);
			$wp_customize->add_control( 'cryptocurrency_exchange_insta_link_disable', array(
					'type'        => 'checkbox',
					'label'       => __('Disable Instagram Icon?', 'cryptocurrency-exchange'),
					'section'     => 'cryptocurrency_exchange_topbar_settings',
					'priority' 	  => 4,
				)
			);
			
			$wp_customize->add_setting('cryptocurrency_exchange_instagram_url', array(
					'default' 			=> '',
					'sanitize_callback' => 'esc_url_raw'
					) 
				);
			$wp_customize->add_control('cryptocurrency_exchange_instagram_url', array(
					'description'	=> __('Enter your Instagram url', 'cryptocurrency-exchange'),
					'section' 		=> 'cryptocurrency_exchange_topbar_settings',
					'type' 			=> 'url',
					'priority' 		=> 4,
				)
			);
			//YouTube URL
			$wp_customize->add_setting( 'cryptocurrency_exchange_youtube_link_disable', array(
					'default'           => 1,
					'sanitize_callback' => 'cryptocurrency_exchange_sanitize_checkbox',
				)
			);
			$wp_customize->add_control( 'cryptocurrency_exchange_youtube_link_disable', array(
					'type'        => 'checkbox',
					'label'       => __('Disable YouTube Icon?', 'cryptocurrency-exchange'),
					'section'     => 'cryptocurrency_exchange_topbar_settings',
					'priority' 	  => 4,
				)
			);
			
			$wp_customize->add_setting('cryptocurrency_exchange_youtube_url', array(
					'default'			=> '',
					'sanitize_callback' => 'esc_url_raw'
					) 
				);
			$wp_customize->add_control('cryptocurrency_exchange_youtube_url', array(
					'description' 	=> __('Enter your YouTube url', 'cryptocurrency-exchange'),
					'section' 		=> 'cryptocurrency_exchange_topbar_settings',
					'type' 			=> 'url',
					'priority' 		=> 4,
				)
			);
						
		//Footer Settings
		$wp_customize->add_section( 'cryptocurrency_exchange_footer_settings' , array(
				'title'      	=> __( 'Footer Settings', 'cryptocurrency-exchange' ),
				'priority'      => 6,
				'panel'			=> 'cryptocurrency_exchange_theme_options',
			) 
		);
			//Enable Widget			
			$wp_customize->add_setting( 'cryptocurrency_exchange_widgets_section', array(
					'default'      		=> 'inactive',
					'sanitize_callback' => 'cryptocurrency_exchange_sanitize_radio'
				)
			);
			$wp_customize->add_control('cryptocurrency_exchange_widgets_section', array(
					'type'      => 'radio',
					'label'     => __('Widgets Section', 'cryptocurrency-exchange'),
					'section'   => 'cryptocurrency_exchange_footer_settings',
					'settings'   => 'cryptocurrency_exchange_widgets_section',
					'priority'  => 1,
					'choices'   => array(
						'active'       => __( 'Active', 'cryptocurrency-exchange' ),
						'inactive'     => __( 'Inactive', 'cryptocurrency-exchange' ),
					),
				)
			);
			

			//Footer Column Layout
			$wp_customize->add_setting( 'cryptocurrency_exchange_footer_column_layout', array(
					'default'      		=> '3',
					'sanitize_callback' => 'cryptocurrency_exchange_sanitize_radio',
				)
			);
			$wp_customize->add_control('cryptocurrency_exchange_footer_column_layout', array(
					'type'      => 'radio',
					'label'     => __('Footer Column Layout', 'cryptocurrency-exchange'),
					'section'   => 'cryptocurrency_exchange_footer_settings',
					'priority'  => 3,
					'choices'   => array(
						'1'   	=> __( 'One Column', 'cryptocurrency-exchange' ),
						'2'    	=> __( 'Two Column', 'cryptocurrency-exchange' ),
						'3'   	=> __( 'Three Column', 'cryptocurrency-exchange' ),
						'4'    	=> __( 'Four Column', 'cryptocurrency-exchange' ),
					),
				)
			);	
}
add_action( 'customize_register', 'cryptocurrency_exchange_customize_register' );


/**
	Sanitize
**/
//checkbox sanitization function
function cryptocurrency_exchange_sanitize_checkbox( $input ) {
	if ( $input == 1 ) {
		return 1;
	} else {
		return 0;
	}
}
     
//radio box sanitization function
function cryptocurrency_exchange_sanitize_radio( $input, $setting ) {
 
	//input must be a slug: lowercase alphanumeric characters, dashes and underscores are allowed only
	$input = sanitize_key($input);

	//get the list of possible radio box options 
	$choices = $setting->manager->get_control( $setting->id )->choices;
					 
	//return input if valid or return default option
	return ( array_key_exists( $input, $choices ) ? $input : $setting->default );                
	 
}

//select sanitization function
function cryptocurrency_exchange_sanitize_select( $input, $setting ) {
 
	//input must be a slug: lowercase alphanumeric characters, dashes and underscores are allowed only
	$input = sanitize_key($input);

	//get the list of possible select options 
	$choices = $setting->manager->get_control( $setting->id )->choices;

	//return input if valid or return default option
	return ( array_key_exists( $input, $choices ) ? $input : $setting->default );                
	 
}

/**
 * Function to sanitize alpha color.
 *
 * @param string $input Hex or RGBA color.
 *
 * @return string
 */
function cryptocurrency_exchange_sanitize_hex_colors( $input ) {
	// Is this an rgba color or a hex?
	$mode = ( false === strpos( $input, 'rgba' ) ) ? 'hex' : 'rgba';

	if ( 'rgba' === $mode ) {
		return cryptocurrency_exchange_sanitize_rgba( $input );
	} else {
		return sanitize_hex_color( $input );
	}
}
?>